import { Component as IntactComponent, Props, ComponentClass, VNodeComponentClass, IntactDom } from 'intact';
import Vue, { ComponentOptions, VNode as VueVNode } from 'vue';
import { normalizeChildren } from './normalize';
import { functionalWrapper } from './functionalWrapper';
export * from 'intact';
export { normalizeChildren as normalize };
declare const mountedQueueStack: Function[][];
export { mountedQueueStack };
export declare class Component<P = {}, E = {}, B = {}> extends IntactComponent<P, E, B> implements Vue {
    static cid: string;
    static options: any;
    static config: import("vue/types/vue").VueConfiguration;
    static $cid: string;
    static $doubleVNodes: boolean;
    static normalize: typeof normalizeChildren;
    static functionalWrapper: typeof functionalWrapper;
    static extend: any;
    static nextTick: any;
    static set: any;
    static delete: any;
    static directive: any;
    static filter: any;
    static component: any;
    static use: any;
    static mixin: any;
    static compile: any;
    static observable: any;
    static util: any;
    static version: any;
    $isVue?: boolean;
    _vnode?: VueVNode;
    $el: Element;
    $options: ComponentOptions<Vue>;
    $root: Vue;
    $parent: any;
    $children: Vue[];
    $refs: any;
    $slots: any;
    $scopedSlots: any;
    $isServer: any;
    $data: any;
    $ssrContext: any;
    $vnode: any;
    $attrs: any;
    $listeners: any;
    $set: any;
    $delete: any;
    $watch: any;
    $on: any;
    $once: any;
    $off: any;
    $emit: any;
    $nextTick: any;
    $createElement: any;
    _render: any;
    _update: any;
    private _isMounted;
    private $isForceUpdating;
    private $seniorComponent;
    private $scopeId;
    constructor(options: any, $vNode?: VNodeComponentClass, $SVG?: boolean, $mountedQueue?: Function[], $senior?: ComponentClass | null);
    constructor(props: Props<P, Component<P>> | null | undefined, $vNode: VNodeComponentClass, $SVG: boolean, $mountedQueue: Function[], $senior: ComponentClass | null);
    $render(lastVNode: VNodeComponentClass<this> | null, nextVNode: VNodeComponentClass<this>, parentDom: Element, anchor: IntactDom | null, mountedQueue: Function[]): void;
    $mount(el: Element | undefined, hydrating: boolean): this;
    $mount(lastVNode: VNodeComponentClass<this> | null, nextVNode: VNodeComponentClass<this>): void;
    $update(lastVNode: VNodeComponentClass<this>, nextVNode: VNodeComponentClass<this>, parentDom: Element, anchor: IntactDom | null, mountedQueue: Function[], force: boolean, fromPrepatch?: boolean): void;
    $forceUpdate(): void;
    $destroy(): void;
    private _$update;
}
